---
title: BluetoothRemoteGATTCharacteristic
slug: Web/API/BluetoothRemoteGATTCharacteristic
tags:
  - API
  - Bluetooth
  - BluetoothGattCharacteristic
  - Experimental
  - Interface
  - Reference
  - Web Bluetooth API
---
<div>{{APIRef("Bluetooth API")}}{{SeeCompatTable}}</div>

<p>The <code>BluetoothRemoteGattCharacteristic</code> interface of the <a href="/en-US/docs/Web/API/Web_Bluetooth_API">Web Bluetooth API</a> represents a GATT Characteristic, which is a basic data element that provides further information about a peripheral’s service.</p>

<h2 id="Interface">Interface</h2>

<pre>interface BluetoothRemoteGATTCharacteristic {
  readonly attribute BluetoothRemoteGATTService service;
  readonly attribute UUID uuid;
  readonly attribute BluetoothCharacteristicProperties properties;
  readonly attribute DataView? value;
  Promise&lt;BluetoothRemoteGATTDescriptor&gt; getDescriptor(BluetoothDescriptorUUID <dfn>descriptor</dfn>);
  Promise&lt;sequence&lt;BluetoothRemoteGATTDescriptor&gt;&gt;
    getDescriptors(optional BluetoothDescriptorUUID <dfn>descriptor</dfn>);
  Promise&lt;DataView&gt; readValue();
  Promise&lt;void&gt; writeValue(BufferSource <dfn>value</dfn>);
  Promise&lt;void&gt; startNotifications();
  Promise&lt;void&gt; stopNotifications();
};
BluetoothRemoteGATTCharacteristic implements EventTarget;
BluetoothRemoteGATTCharacteristic implements CharacteristicEventHandlers;</pre>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{DOMxRef("BluetoothRemoteGATTCharacteristic.service")}}{{ReadOnlyInline}}</dt>
 <dd>Returns the {{DOMxRef("BluetoothGATTService")}} this characteristic belongs to.</dd>
 <dt>{{DOMxRef("BluetoothRemoteGATTCharacteristic.uuid")}}{{ReadOnlyInline}}</dt>
 <dd>Returns a {{DOMxRef("DOMString")}} containing the UUID of the characteristic, for example <code>'00002a37-0000-1000-8000-00805f9b34fb'</code> for the Heart Rate Measurement characteristic.</dd>
 <dt>{{DOMxRef("BluetoothRemoteGATTCharacteristic.properties")}}{{ReadOnlyInline}}</dt>
 <dd>Returns the properties of this characteristic.</dd>
 <dt>{{DOMxRef("BluetoothRemoteGATTCharacteristic.value")}}{{ReadOnlyInline}}</dt>
 <dd>The currently cached characteristic value. This value gets updated when the value of the characteristic is read or updated via a notification or indication.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{DOMxRef("BluetoothRemoteGATTCharacteristic.getDescriptor()")}}</dt>
 <dd>Returns a {{JSxRef("Promise")}} that resolves to the first {{DOMxRef("BluetoothGATTDescriptor")}} for a given descriptor UUID.</dd>
 <dt>{{DOMxRef("BluetoothRemoteGATTCharacteristic.getDescriptors()")}}</dt>
 <dd>Returns a {{JSxRef("Promise")}} that resolves to an {{JSxRef("Array")}} of all {{DOMxRef("BluetoothGATTDescriptor")}} objects for a given descriptor UUID.</dd>
 <dt>{{DOMxRef("BluetoothRemoteGATTCharacteristic.readValue()")}}</dt>
 <dd>Returns a {{JSxRef("Promise")}} that resolves to an {{JSxRef("ArrayBuffer")}} holding a duplicate of the <code>value</code> property if it is available and supported. Otherwise it throws an error.</dd>
 <dt>{{DOMxRef("BluetoothRemoteGATTCharacteristic.writeValue()")}}</dt>
 <dd>Sets the value property to the bytes contained in an {{JSxRef("ArrayBuffer")}} and returns a {{JSxRef("Promise")}}.</dd>
 <dt>{{DOMxRef("BluetoothRemoteGATTCharacteristic.startNotifications()")}}</dt>
 <dd>Returns a {{JSxRef("Promise")}} when <code>navigator.bluetooth</code> is added to the active notification context.</dd>
 <dt>{{DOMxRef("BluetoothRemoteGATTCharacteristic.stopNotifications()")}}</dt>
 <dd>Returns a {{JSxRef("Promise")}} when <code>navigator.bluetooth</code> is removed from the active notification context.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Web Bluetooth", "#bluetoothremotegattcharacteristic", "BluetoothRemoteGATTCharacteristic")}}</td>
   <td>{{Spec2("Web Bluetooth")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.BluetoothRemoteGATTCharacteristic")}}</p>
